<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="OSULUG – Robert Detjens">
  <meta name="dcterms.date" content="2021-10-14">
  <title>Introduction to Git and Github</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reset.css">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reveal.css">
  <style>
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    pre > code.sourceCode { white-space: pre; position: relative; }
    pre > code.sourceCode > span { display: inline-block; line-height: 1.25; }
    pre > code.sourceCode > span:empty { height: 1.2em; }
    .sourceCode { overflow: visible; }
    code.sourceCode > span { color: inherit; text-decoration: inherit; }
    div.sourceCode { margin: 1em 0; }
    pre.sourceCode { margin: 0; }
    @media screen {
    div.sourceCode { overflow: auto; }
    }
    @media print {
    pre > code.sourceCode { white-space: pre-wrap; }
    pre > code.sourceCode > span { text-indent: -5em; padding-left: 5em; }
    }
    pre.numberSource code
      { counter-reset: source-line 0; }
    pre.numberSource code > span
      { position: relative; left: -4em; counter-increment: source-line; }
    pre.numberSource code > span > a:first-child::before
      { content: counter(source-line);
        position: relative; left: -1em; text-align: right; vertical-align: baseline;
        border: none; display: inline-block;
        -webkit-touch-callout: none; -webkit-user-select: none;
        -khtml-user-select: none; -moz-user-select: none;
        -ms-user-select: none; user-select: none;
        padding: 0 4px; width: 4em;
        color: #aaaaaa;
      }
    pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
    div.sourceCode
      {   }
    @media screen {
    pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
    }
    code span.al { color: #ff0000; font-weight: bold; } /* Alert */
    code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
    code span.at { color: #7d9029; } /* Attribute */
    code span.bn { color: #40a070; } /* BaseN */
    code span.bu { } /* BuiltIn */
    code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
    code span.ch { color: #4070a0; } /* Char */
    code span.cn { color: #880000; } /* Constant */
    code span.co { color: #60a0b0; font-style: italic; } /* Comment */
    code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
    code span.do { color: #ba2121; font-style: italic; } /* Documentation */
    code span.dt { color: #902000; } /* DataType */
    code span.dv { color: #40a070; } /* DecVal */
    code span.er { color: #ff0000; font-weight: bold; } /* Error */
    code span.ex { } /* Extension */
    code span.fl { color: #40a070; } /* Float */
    code span.fu { color: #06287e; } /* Function */
    code span.im { } /* Import */
    code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
    code span.kw { color: #007020; font-weight: bold; } /* Keyword */
    code span.op { color: #666666; } /* Operator */
    code span.ot { color: #007020; } /* Other */
    code span.pp { color: #bc7a00; } /* Preprocessor */
    code span.sc { color: #4070a0; } /* SpecialChar */
    code span.ss { color: #bb6688; } /* SpecialString */
    code span.st { color: #4070a0; } /* String */
    code span.va { color: #19177c; } /* Variable */
    code span.vs { color: #4070a0; } /* VerbatimString */
    code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/theme/black.css" id="theme">
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section id="title-slide">
  <h1 class="title">Introduction to Git and Github</h1>
  <p class="author">OSULUG – Robert Detjens</p>
  <p class="date">10/14/21</p>
</section>

<section>
<section id="what-on-earth-is-git" class="title-slide slide level1">
<h1>What on earth is <code>git</code>?</h1>

</section>
<section id="version-control" class="slide level2">
<h2>version control!</h2>
<p>created in 2005 by Linus Torvalds for the Linux kernel</p>
</section></section>
<section>
<section id="what-on-earth-is-version-control" class="title-slide slide level1">
<h1>What on earth is version control?</h1>

</section>
<section id="avoids-this" class="slide level2">
<h2>Avoids this:</h2>
<ul>
<li><code>hw_final.doc</code></li>
<li><code>hw_final2.doc</code></li>
<li><code>hw_final_no_really_this_time.doc</code></li>
<li><code>hw_aaaaaaaaaa.doc</code></li>
</ul>
</section>
<section id="instead" class="slide level2">
<h2>Instead:</h2>
<ul>
<li>a “commit” saves the state of the repo (the folder being tracked)</li>
<li>keeps track of changes between commits</li>
<li>can revert back to any previous state</li>
<li>somewhat like a linked list of diffs</li>
</ul>
</section>
<section id="useful-for" class="slide level2">
<h2>Useful for:</h2>
<ul>
<li>source code</li>
<li>notes</li>
<li>homework</li>
<li>anything that needs backups</li>
</ul>
</section></section>
<section>
<section id="ok-thats-cool-but-how-do-i-use-this" class="title-slide slide level1">
<h1>OK, thats cool, but how do I use this?</h1>

</section>
<section id="several-gui-frontends" class="slide level2">
<h2>Several GUI frontends</h2>
<ul>
<li>Github Desktop</li>
<li>GitKraken</li>
<li>various editor integrations</li>
</ul>
</section>
<section id="one-command-to-rule-them-all" class="slide level2">
<h2>One command to rule them all</h2>
<p><code>git</code></p>
</section>
<section id="basic-stuff" class="slide level2">
<h2>Basic stuff</h2>
<ul>
<li><code>git clone</code></li>
<li><code>git status</code></li>
<li><code>git add</code></li>
<li><code>git commit</code></li>
<li><code>git push</code></li>
</ul>
</section>
<section id="git-clone" class="slide level2">
<h2><code>git clone</code></h2>
<p><img data-src="images/clone.png" /></p>
<p>Downloads an existing repo to a local folder</p>
<p>Creates a local copy or <em>clone</em></p>
</section>
<section id="git-status" class="slide level2">
<h2><code>git status</code></h2>
<p>Shows the current <strong>status</strong> of the repo</p>
<figure>
<img data-src="images/status-clean.png" alt="no changes since last commit" /><figcaption aria-hidden="true">no changes since last commit</figcaption>
</figure>
</section>
<section id="git-status-1" class="slide level2">
<h2><code>git status</code></h2>
<p>If any files have been changed since the last commit, this will show which ones</p>
<p><img data-src="images/status-dirty.png" /></p>
</section>
<section id="git-diff" class="slide level2">
<h2><code>git diff</code></h2>
<p>Shows what has changed in those files (the <em>diff</em>erence)</p>
<p><img data-src="images/diff.png" style="width:50.0%" /></p>
</section>
<section id="git-add" class="slide level2">
<h2><code>git add</code></h2>
<p>Tells git to add some changed files to the next commit</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode sh"><code class="sourceCode bash"><span id="cb1-1"><a href="#cb1-1" aria-hidden="true" tabindex="-1"></a><span class="co"># add all changed files</span></span>
<span id="cb1-2"><a href="#cb1-2" aria-hidden="true" tabindex="-1"></a><span class="ex">$</span> git add <span class="at">--all</span></span>
<span id="cb1-3"><a href="#cb1-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-4"><a href="#cb1-4" aria-hidden="true" tabindex="-1"></a><span class="co"># or just specific ones</span></span>
<span id="cb1-5"><a href="#cb1-5" aria-hidden="true" tabindex="-1"></a><span class="ex">$</span> git add foo.md bar.md images/clouds.png</span></code></pre></div>
</section>
<section id="git-add-1" class="slide level2">
<h2><code>git add</code></h2>
<p><code>git status</code> will show what files have been added</p>
<p><img data-src="images/status-add.png" /></p>
</section>
<section id="git-commit" class="slide level2">
<h2><code>git commit</code></h2>
<p>Actually saves the added files’ changes to the repo</p>
<p>This will open up <code>$EDITOR</code> for a commit message</p>
<p><img data-src="images/commit.png" /></p>
</section>
<section id="git-log" class="slide level2">
<h2><code>git log</code></h2>
<p>Shows the commit history</p>
<p><img data-src="images/log.png" /></p>
</section>
<section id="git-push" class="slide level2">
<h2><code>git push</code></h2>
<p>Sends commits to the remote repo</p>
<pre><code>$ git push
Enumerating objects: 333, done.
Counting objects: 100% (333/333), done.
Delta compression using up to 12 threads
Compressing objects: 100% (122/122), done.
Writing objects: 100% (326/326), 54.25 KiB | 54.25 MiB/s, done.
Total 326 (delta 193), reused 313 (delta 184), pack-reused 0
remote: Resolving deltas: 100% (193/193), completed with 5 local objects.</code></pre>
</section></section>
<section>
<section id="github" class="title-slide slide level1">
<h1>GitHub</h1>

</section>
<section id="what-is-github" class="slide level2">
<h2>What is GitHub?</h2>
<ul>
<li>Git repo hosting</li>
<li>Web interface for repo management</li>
<li>Adds collaboration features
<ul>
<li>issues</li>
<li>easy <strong>pull requests</strong></li>
<li>CI</li>
<li>etc</li>
</ul></li>
</ul>
</section>
<section id="how-use" class="slide level2">
<h2>How use?</h2>
<p>Create a repo and clone it locally</p>
<p>Edit the repo as shown before</p>
<p>Push committed changes back to GitHub</p>
</section>
<section id="what-is-a-pull-merge-request" class="slide level2">
<h2>What is a pull / merge request?</h2>
<p>A way to request that a branch is merged into another</p>
</section></section>
<section>
<section id="branches" class="title-slide slide level1">
<h1>Branches</h1>

</section>
<section id="branch-merge-what" class="slide level2">
<h2>Branch? Merge? What?</h2>
<figure>
<img data-src="https://blog.seibert-media.net/wp-content/uploads/2015/07/Git-Branches-1.png" style="height:30.0%" alt="git has the concept of branches" /><figcaption aria-hidden="true"><code>git</code> has the concept of branches</figcaption>
</figure>
</section>
<section id="working-with-branches" class="slide level2">
<h2>Working with branches</h2>
<pre><code>$ git checkout -B a-new-branch</code></pre>
<p>Commits are added to the current branch</p>
<p><code>git status</code> shows the current branch:</p>
<pre><code>$ git status
On branch a-new-branch

nothing to commit, working tree clean</code></pre>
</section>
<section id="branch-workflow" class="slide level2">
<h2>Branch workflow</h2>
<ul>
<li>make new branch</li>
<li>add feature / bugfix / etc to branch</li>
<li>make PR to merge branch into <code>main</code></li>
<li>reviewed &amp; merged</li>
</ul>
</section>
<section id="merging" class="slide level2">
<h2>Merging</h2>
<p>Branches can be combined with a <strong>merge</strong></p>
</section>
<section id="feature-branch" class="slide level2">
<h2>Feature branch</h2>
<p><img data-src="https://wac-cdn.atlassian.com/dam/jcr:7afd8460-b7bf-4c42-b997-4f5cf24f21e8/01%20Branch-2%20kopiera.png?cdnVersion=1852" /></p>
</section>
<section id="merging-back-into-main" class="slide level2">
<h2>Merging back into <code>main</code></h2>
<p><img data-src="https://wac-cdn.atlassian.com/dam/jcr:c6db91c1-1343-4d45-8c93-bdba910b9506/02%20Branch-1%20kopiera.png?cdnVersion=1852" /></p>
</section>
<section id="rebasing" class="slide level2">
<h2>Rebasing</h2>
<p>Branches “branch off” from an original branch</p>
<figure>
<img data-src="https://blogs.atlassian.com/wp-content/uploads/rebase-diagram-adg3.png" style="width:40.0%" alt="Rebasing moves that point to a different commit" /><figcaption aria-hidden="true">Rebasing moves that point to a different commit</figcaption>
</figure>
</section>
<section id="merge-conflicts" class="slide level2">
<h2>Merge conflicts</h2>
<p>What happens when two commits try to modify the same file?</p>
<p><code>git</code> doesn’t know what to do and stops for manual resolution</p>
<p>– demo –</p>
</section></section>
<section id="any-questions" class="title-slide slide level1">
<h1>Any questions?</h1>

</section>
    </div>
  </div>

  <script src="https://unpkg.com/reveal.js@^4//dist/reveal.js"></script>

  <!-- reveal.js plugins -->
  <script src="https://unpkg.com/reveal.js@^4//plugin/notes/notes.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/search/search.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/zoom/zoom.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://revealjs.com/config/
      Reveal.initialize({
        // Display controls in the bottom right corner
        controls: true,

        // Help the user learn the controls by providing hints, for example by
        // bouncing the down arrow when they first encounter a vertical slide
        controlsTutorial: true,

        // Determines where controls appear, "edges" or "bottom-right"
        controlsLayout: 'bottom-right',

        // Visibility rule for backwards navigation arrows; "faded", "hidden"
        // or "visible"
        controlsBackArrows: 'faded',

        // Display a presentation progress bar
        progress: true,

        // Display the page number of the current slide
        slideNumber: false,

        // 'all', 'print', or 'speaker'
        showSlideNumber: 'all',

        // Add the current slide number to the URL hash so that reloading the
        // page/copying the URL will return you to the same slide
        hash: false,

        // Start with 1 for the hash rather than 0
        hashOneBasedIndex: false,

        // Flags if we should monitor the hash and change slides accordingly
        respondToHashChanges: true,

        // Push each slide change to the browser history
        history: false,

        // Enable keyboard shortcuts for navigation
        keyboard: true,

        // Enable the slide overview mode
        overview: true,

        // Disables the default reveal.js slide layout (scaling and centering)
        // so that you can use custom CSS layout
        disableLayout: false,

        // Vertical centering of slides
        center: true,

        // Enables touch navigation on devices with touch input
        touch: true,

        // Loop the presentation
        loop: false,

        // Change the presentation direction to be RTL
        rtl: false,

        // see https://revealjs.com/vertical-slides/#navigation-mode
        navigationMode: 'default',

        // Randomizes the order of slides each time the presentation loads
        shuffle: false,

        // Turns fragments on and off globally
        fragments: true,

        // Flags whether to include the current fragment in the URL,
        // so that reloading brings you to the same fragment position
        fragmentInURL: true,

        // Flags if the presentation is running in an embedded mode,
        // i.e. contained within a limited portion of the screen
        embedded: false,

        // Flags if we should show a help overlay when the questionmark
        // key is pressed
        help: true,

        // Flags if it should be possible to pause the presentation (blackout)
        pause: true,

        // Flags if speaker notes should be visible to all viewers
        showNotes: false,

        // Global override for autoplaying embedded media (null/true/false)
        autoPlayMedia: null,

        // Global override for preloading lazy-loaded iframes (null/true/false)
        preloadIframes: null,

        // Number of milliseconds between automatically proceeding to the
        // next slide, disabled when set to 0, this value can be overwritten
        // by using a data-autoslide attribute on your slides
        autoSlide: 0,

        // Stop auto-sliding after user input
        autoSlideStoppable: true,

        // Use this method for navigation when auto-sliding
        autoSlideMethod: null,

        // Specify the average time in seconds that you think you will spend
        // presenting each slide. This is used to show a pacing timer in the
        // speaker view
        defaultTiming: null,

        // Enable slide navigation via mouse wheel
        mouseWheel: false,

        // The display mode that will be used to show slides
        display: 'block',

        // Hide cursor if inactive
        hideInactiveCursor: true,

        // Time before the cursor is hidden (in ms)
        hideCursorTime: 5000,

        // Opens links in an iframe preview overlay
        previewLinks: false,

        // Transition style (none/fade/slide/convex/concave/zoom)
        transition: 'slide',

        // Transition speed (default/fast/slow)
        transitionSpeed: 'default',

        // Transition style for full page slide backgrounds
        // (none/fade/slide/convex/concave/zoom)
        backgroundTransition: 'fade',

        // Number of slides away from the current that are visible
        viewDistance: 3,

        // Number of slides away from the current that are visible on mobile
        // devices. It is advisable to set this to a lower number than
        // viewDistance in order to save resources.
        mobileViewDistance: 2,

        // reveal.js plugins
        plugins: [
          RevealNotes,
          RevealSearch,
          RevealZoom
        ]
      });
    </script>
    </body>
</html>
